<template>
  <section>
    <v-layout wrap ma-6 justify-center>
      <v-flex md12 px-2>
        <h1>Numero de Compras: {{compras}}</h1>
        <h1>Población Total: {{precioFormat(poblacion)}}</h1>
        <h1>Promedio Población: {{precioFormat(promedio)}}</h1>
        <h1>Área Total: {{precioFormat(area)}}</h1>
        <h1>Paises Favoritos: {{likes}}</h1>
        <v-btn @click="reset()" color="blue lighten-3" dark>Reiniciar</v-btn>
      </v-flex>
      <v-flex v-for="(pais,index) in paises" :key="index" sm3 xs12 px-2 mb-5>
        <v-card class="mx-auto">
          <v-img class="white--text" height="180px" v-bind:src="pais.flag" />
          <v-card-title>{{pais.name}}</v-card-title>
          <v-card-text>
            <div class="subtitle-1">Capital: {{pais.capital}}</div>
            <div class="subtitle1">Población:{{precioFormat(pais.population)}}</div>
          </v-card-text>
          <v-card-actions>
            <v-btn
              :color="likesArray[index] ? 'red':'default'"
              icon
              @click="like(likesArray[index], index)"
            >
              <v-icon>mdi-heart</v-icon>
            </v-btn>
            <v-spacer />
            <v-btn outlined @click="agregar(pais.population, pais.area, pais)">Agregar</v-btn>
          </v-card-actions>
        </v-card>
      </v-flex>
    </v-layout>
  </section>
</template>

<script>
//Llamado a los Helpers
import { mapState, mapGetters, mapMutations, mapActions } from "vuex";
export default {
  data() {
    return {
      likesArray: []
    };
  },
  computed: {
    //Llamados a los datos de las variables de Store.
    ...mapState(["compras"]),
    ...mapState(["poblacion"]),
    ...mapState(["area"]),
    ...mapState(["paises"]),
    ...mapState(["likes"]),
    ...mapState(["paisesAgregados"]),
    ...mapState(["paisesConLike"]),
    //Llamado al getter.
    ...mapGetters(["promedio"]),
    ...mapGetters(["ultimosPaisesAgregados"])
  },
  created() {
    //Se llama a la action para obtener los países
    this.getAllCountries();
  },
  methods: {
    //Llama a las mutaciones del Store para que puedan utilizarse como metodos.
    ...mapMutations(["setLikes"]),
    ...mapMutations(["nuevaCompra"]),
    ...mapMutations(["agregarArea"]),

    ...mapMutations(["agregarPais"]),
    ...mapMutations(["reset"]),
    ...mapMutations(["agregarLike"]),
    ...mapMutations(["quitarLike"]),

    //Llamado a Actions para ser utilizado como un metodo local.
    ...mapActions(["getAllCountries"]),
    /*Método para cambiar el formato del precio mostrado en la vista
 (Población de la respuesta obtenida de la API)*/
    precioFormat(population) {
      return population.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
    },

    /*Método que realiza un commit (mutation) con el objetivo de
 aumentar o disminuir la cantidad de likes según
 el estado del objeto al cual se le dio like*/
    like(estado, index) {
      this.likesArray[index] = !estado;
      let like = this.likesArray[index];
      if(this.likesArray[index]){
         this.agregarLike(index)
      }
      this.setLikes(like);
    },
    /*Método que realiza un commit para aumentar el contador de compras
 y asignar el precio a la variable state.costos creada y llamada
 en el mutation nuevaCompra*/
    agregar(precio, area, pais) {
      this.nuevaCompra(precio);
      this.agregarArea(area);
      this.agregarPais(pais);
    },
    reset() {
      this.reset();
    }
  }
};
</script>

<style>
</style>